# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/config/accesslog/v2/file.proto, envoy/config/accesslog/v2/als.proto
# plugin: python-betterproto
from dataclasses import dataclass
from datetime import timedelta
from typing import List, Optional

import betterproto


@dataclass(eq=False, repr=False)
class FileAccessLog(betterproto.Message):
    """
    Custom configuration for an :ref:`AccessLog
    <envoy_api_msg_config.filter.accesslog.v2.AccessLog>` that writes log
    entries directly to a file. Configures the built-in
    *envoy.access_loggers.file* AccessLog.
    """

    # A path to a local file to which to write the access log entries.
    path: str = betterproto.string_field(1)
    # Access log :ref:`format string<config_access_log_format_strings>`. Envoy
    # supports :ref:`custom access log formats <config_access_log_format>` as
    # well as a :ref:`default format <config_access_log_default_format>`.
    format: str = betterproto.string_field(2, group="access_log_format")
    # Access log :ref:`format dictionary<config_access_log_format_dictionaries>`.
    # All values are rendered as strings.
    json_format: "betterproto_lib_google_protobuf.Struct" = betterproto.message_field(
        3, group="access_log_format"
    )
    # Access log :ref:`format dictionary<config_access_log_format_dictionaries>`.
    # Values are rendered as strings, numbers, or boolean values as appropriate.
    # Nested JSON objects may be produced by some command operators
    # (e.g.FILTER_STATE or DYNAMIC_METADATA). See the documentation for a
    # specific command operator for details.
    typed_json_format: "betterproto_lib_google_protobuf.Struct" = (
        betterproto.message_field(4, group="access_log_format")
    )

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class HttpGrpcAccessLogConfig(betterproto.Message):
    """
    Custom configuration for an :ref:`AccessLog
    <envoy_api_msg_config.filter.accesslog.v2.AccessLog>` that writes log
    entries directly to a file. Configures the built-in
    *envoy.access_loggers.file* AccessLog.
    """

    # A path to a local file to which to write the access log entries.
    common_config: "CommonGrpcAccessLogConfig" = betterproto.message_field(1)
    # Access log :ref:`format string<config_access_log_format_strings>`. Envoy
    # supports :ref:`custom access log formats <config_access_log_format>` as
    # well as a :ref:`default format <config_access_log_default_format>`.
    additional_request_headers_to_log: List[str] = betterproto.string_field(2)
    # Access log :ref:`format dictionary<config_access_log_format_dictionaries>`.
    # All values are rendered as strings.
    additional_response_headers_to_log: List[str] = betterproto.string_field(3)
    # Access log :ref:`format dictionary<config_access_log_format_dictionaries>`.
    # Values are rendered as strings, numbers, or boolean values as appropriate.
    # Nested JSON objects may be produced by some command operators
    # (e.g.FILTER_STATE or DYNAMIC_METADATA). See the documentation for a
    # specific command operator for details.
    additional_response_trailers_to_log: List[str] = betterproto.string_field(4)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class TcpGrpcAccessLogConfig(betterproto.Message):
    common_config: "CommonGrpcAccessLogConfig" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class CommonGrpcAccessLogConfig(betterproto.Message):
    log_name: str = betterproto.string_field(1)
    grpc_service: "___api_v2_core__.GrpcService" = betterproto.message_field(2)
    buffer_flush_interval: timedelta = betterproto.message_field(3)
    buffer_size_bytes: Optional[int] = betterproto.message_field(
        4, wraps=betterproto.TYPE_UINT32
    )
    filter_state_objects_to_log: List[str] = betterproto.string_field(5)

    def __post_init__(self) -> None:
        super().__post_init__()


from ....api.v2 import core as ___api_v2_core__
import betterproto.lib.google.protobuf as betterproto_lib_google_protobuf
