# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/type/v3/range.proto, envoy/type/v3/hash_policy.proto, envoy/type/v3/percent.proto, envoy/type/v3/http.proto, envoy/type/v3/semantic_version.proto, envoy/type/v3/http_status.proto, envoy/type/v3/ratelimit_unit.proto, envoy/type/v3/token_bucket.proto
# plugin: python-betterproto
from dataclasses import dataclass
from datetime import timedelta
from typing import Optional

import betterproto


class FractionalPercentDenominatorType(betterproto.Enum):
    HUNDRED = 0
    TEN_THOUSAND = 1
    MILLION = 2


class CodecClientType(betterproto.Enum):
    HTTP1 = 0
    HTTP2 = 1
    HTTP3 = 2


class StatusCode(betterproto.Enum):
    Empty = 0
    Continue = 100
    OK = 200
    Created = 201
    Accepted = 202
    NonAuthoritativeInformation = 203
    NoContent = 204
    ResetContent = 205
    PartialContent = 206
    MultiStatus = 207
    AlreadyReported = 208
    IMUsed = 226
    MultipleChoices = 300
    MovedPermanently = 301
    Found = 302
    SeeOther = 303
    NotModified = 304
    UseProxy = 305
    TemporaryRedirect = 307
    PermanentRedirect = 308
    BadRequest = 400
    Unauthorized = 401
    PaymentRequired = 402
    Forbidden = 403
    NotFound = 404
    MethodNotAllowed = 405
    NotAcceptable = 406
    ProxyAuthenticationRequired = 407
    RequestTimeout = 408
    Conflict = 409
    Gone = 410
    LengthRequired = 411
    PreconditionFailed = 412
    PayloadTooLarge = 413
    URITooLong = 414
    UnsupportedMediaType = 415
    RangeNotSatisfiable = 416
    ExpectationFailed = 417
    MisdirectedRequest = 421
    UnprocessableEntity = 422
    Locked = 423
    FailedDependency = 424
    UpgradeRequired = 426
    PreconditionRequired = 428
    TooManyRequests = 429
    RequestHeaderFieldsTooLarge = 431
    InternalServerError = 500
    NotImplemented = 501
    BadGateway = 502
    ServiceUnavailable = 503
    GatewayTimeout = 504
    HTTPVersionNotSupported = 505
    VariantAlsoNegotiates = 506
    InsufficientStorage = 507
    LoopDetected = 508
    NotExtended = 510
    NetworkAuthenticationRequired = 511


class RateLimitUnit(betterproto.Enum):
    UNKNOWN = 0
    SECOND = 1
    MINUTE = 2
    HOUR = 3
    DAY = 4


@dataclass(eq=False, repr=False)
class Int64Range(betterproto.Message):
    """
    Specifies the int64 start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    start: int = betterproto.int64_field(1)
    # end of the range (exclusive)
    end: int = betterproto.int64_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Int32Range(betterproto.Message):
    """
    Specifies the int32 start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    start: int = betterproto.int32_field(1)
    # end of the range (exclusive)
    end: int = betterproto.int32_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class DoubleRange(betterproto.Message):
    """
    Specifies the double start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    start: float = betterproto.double_field(1)
    # end of the range (exclusive)
    end: float = betterproto.double_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class HashPolicy(betterproto.Message):
    """
    Specifies the int64 start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    source_ip: "HashPolicySourceIp" = betterproto.message_field(
        1, group="policy_specifier"
    )

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class HashPolicySourceIp(betterproto.Message):
    pass

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Percent(betterproto.Message):
    """
    Specifies the int64 start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    value: float = betterproto.double_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class FractionalPercent(betterproto.Message):
    """
    Specifies the int32 start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    numerator: int = betterproto.uint32_field(1)
    # end of the range (exclusive)
    denominator: "FractionalPercentDenominatorType" = betterproto.enum_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class SemanticVersion(betterproto.Message):
    """
    Specifies the int64 start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    major_number: int = betterproto.uint32_field(1)
    # end of the range (exclusive)
    minor_number: int = betterproto.uint32_field(2)
    patch: int = betterproto.uint32_field(3)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class HttpStatus(betterproto.Message):
    """
    Specifies the int64 start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    code: "StatusCode" = betterproto.enum_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class TokenBucket(betterproto.Message):
    """
    Specifies the int64 start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    max_tokens: int = betterproto.uint32_field(1)
    # end of the range (exclusive)
    tokens_per_fill: Optional[int] = betterproto.message_field(
        2, wraps=betterproto.TYPE_UINT32
    )
    fill_interval: timedelta = betterproto.message_field(3)

    def __post_init__(self) -> None:
        super().__post_init__()
